<template>
    <v-container fluid>
        <v-form :style="styleObject" class="custom">
            <v-row>

                <template v-for="(item, index) in items" :key="index">
                    <v-col class="v-col" cols="12" :md="md">
                        <span>{{ item.placeholder }}</span>

                        <v-text-field variant="outlined" v-model="item.value"
                            :rules="[rules.required,
                            item.type === 'text' ? rules.maxLength : item.type === 'phone' ? rules.phone :
                            item.type === 'email' ? rules.email : item.type === 'isNumber' ? rules.isNumber : item.type === 'password' ? rules.password : '']"
                            :label="item.label" :placeholder="item.placeholder" :type="item.type"
                            :counter="item.text = 'text' ? item.counter : null" required
                            :error-messages="item.type === 'text' ? textErrors : item.type === 'phone' ?
                            phoneErrors : item.type === 'email' ? emailErrors : item.type === 'number' ? numberErrors : item.type === 'password' ? passwordErrors : ''"
                            class="custom-text-field"></v-text-field>

                    </v-col>

                </template>

            </v-row>
        </v-form>
    </v-container>
</template>
  
<script>
export default {
    name: "CustomTextField",
    props: {
        md: {
            type: Number,
            required: true,
        },
        width: {
            type: Number,
            required: true,
        },
        items: {
            type: Array,
            required: true,
        },
    },
    data() {
        return {
            maxCharacters: 30,
            textValue: '',
            phoneValue: '',
            emailValue: '',
            numberValue: '',
            passwordValue: '',
            rules: {
                required: (value) => !!value || 'Zorunlu.',
                maxLength: (value) => value.length <= 30 || 'En fazla ' + this.maxCharacters + ' karakter.',
                phone: (value) =>
                    /^(\+?\d{1,2}[- ]?)?\d{3}[- ]?\d{3}[- ]?\d{4}$/.test(value) ||
                    'Geçersiz telefon numarası.',
                email: (value) =>
                    /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(value) ||
                    'Geçersiz e-posta adresi.',
                isNumber: (value) =>
                    !isNaN(parseFloat(value)) && isFinite(value) ||
                    'Geçersiz numara.',
                password: (value) => /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[a-zA-Z]).{8,}$/gm.test(value) ||
                    'Geçersiz şifre. En az bir büyük harf, bir küçük harf, bir rakam içermeli ve en az 8 karakter uzunluğunda olmalıdır.'
            }
        }
    },
    computed: {
        textErrors() {
            const errors = []
            !this.rules.required(this.textValue) && errors.push('Text field is required.')
            //!this.rules.maxLength(this.textValue) && errors.push('Text field cannot exceed 30 characters.')
            !this.rules.maxLength(this.textValue) && errors.push('Metin alanı 30 karakteri aşamaz.')
            return errors
        },
        phoneErrors() {
            const errors = []
            !this.rules.required(this.phoneValue) && errors.push('Phone number is required.')
            //!this.rules.phone(this.phoneValue) && errors.push('Invalid phone number.')
            !this.rules.phone(this.phoneValue) && errors.push('Geçersiz telefon numarası')
            return errors
        },
        emailErrors() {
            const errors = []
            !this.rules.required(this.emailValue) && errors.push('Email is required.')
            //!this.rules.email(this.emailValue) && errors.push('Invalid email address.')
            !this.rules.email(this.emailValue) && errors.push('Geçersiz e-posta adresi')

            return errors
        },
        numberErrors() {
            const errors = []
            !this.rules.required(this.numberValue) && errors.push('Number is required.')
            //!this.rules.isNumber(this.numberValue) && errors.push('Invalid number.')
            !this.rules.isNumber(this.numberValue) && errors.push('Geçersiz numara.')
            return errors
        },
        passwordErrors() {
            const errors = []
            !this.rules.required(this.passwordValue) && errors.push('Password is required.')
            //!this.rules.password(this.passwordValue) && errors.push('Invalid password. Must contain at least one uppercase letter, one lowercase letter, one number, and be at least 8 characters long.')
            !this.rules.password(this.passwordValue) && errors.push('Geçersiz şifre. En az bir büyük harf, bir küçük harf, bir rakam içermeli ve en az 8 karakter uzunluğunda olmalıdır.')
            return errors
        },
        styleObject() {
            return {
                width: this.width + '%'
            }
        }

    }
}
</script>

<style>
.custom .v-messages.error--text {
    margin-top: 0;
    font-weight: 600;
    font-size: 12px;
    line-height: 17px;
    letter-spacing: -0.333333px;
    color: #E3262F;
}

.custom .v-col-md-4 {
    flex: 0 0 33.3333333333%;
    max-width: 33.3333333333%;
    padding: 0px 30px;
}
.custom span {
    font-weight: 400;
    font-size: 12px;
    line-height: 17px;
    letter-spacing: -0.333333px;
    color: #404040;
}

.custom .custom-text-field .v-text-field__slot::before {
    content: attr(data-placeholder) !important;
    font-size: 14px !important;
    font-weight: 400 !important;
    line-height: 17px !important;
    letter-spacing: -0.333333px !important;
    color: #404040 !important;
    position: absolute !important;
    background: #FAFAFA !important;
    border: 1px solid #E3E3E3 !important;
    border-radius: 4px !important;
}
.custom .v-text-field .v-field--no-label input {
    opacity: 1;
    background: #FAFAFA;
}
.custom .custom-text-field>>>.v-text-field__slot input {
    opacity: 1;
    background: #FAFAFA;
    border: 1px solid #E3E3E3;
    border-radius: 4px;
}
@media (max-width: 600px) {
    .custom .v-col {
        max-width: 100% !important;
        flex: unset !important;
    }

    .custom .v-input__control {
        display: contents;
        grid-area: inherit;
    }

    .custom {
        width: 100% !important;
    }
}
</style>
  